Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members

# PK_CryptoSystem Class Reference

`#include <cryptlib.h>`

Inheritance diagram for PK_CryptoSystem:

List of all members.

## Detailed Description

interface for public-key encryptors and decryptors

This class provides an interface common to encryptors and decryptors for querying their plaintext and ciphertext lengths.

Definition at line 1109 of file cryptlib.h.

## Public Member Functions
virtual | ~PK_CryptoSystem ()
virtual unsigned int | MaxPlaintextLength (unsigned int ciphertextLength) const =0
| maximum length of plaintext for a given ciphertext length
virtual unsigned int | CiphertextLength (unsigned int plaintextLength) const =0
| calculate length of ciphertext given length of plaintext
virtual bool | ParameterSupported (const char *name) const =0
| this object supports the use of the parameter with the given name
virtual unsigned int | FixedCiphertextLength () const
| return fixed ciphertext length, if one exists, otherwise return 0
virtual unsigned int | FixedMaxPlaintextLength () const
| return maximum plaintext length given the fixed ciphertext length, if one exists, otherwise return 0

## Member Function Documentation

virtual unsigned int PK_CryptoSystem::MaxPlaintextLength | ( | unsigned int | ciphertextLength | ) | const`[pure virtual]`

| maximum length of plaintext for a given ciphertext length Note: This function returns 0 if ciphertextLength is not valid (too long or too short). Implemented in PK_FixedLengthCryptoSystemImpl< PK_Encryptor >, PK_FixedLengthCryptoSystemImpl< PK_Decryptor >, DL_CryptoSystemBase< PK_Decryptor, DL_PrivateKey< SCHEME_OPTIONS::Element > >, DL_CryptoSystemBase< PK_Decryptor, DL_PrivateKey< T > >, DL_CryptoSystemBase< PK_Encryptor, DL_PublicKey< SCHEME_OPTIONS::Element > >, and DL_CryptoSystemBase< PK_Encryptor, DL_PublicKey< T > >. Referenced by PK_DefaultDecryptionFilter::Put2().

virtual unsigned int PK_CryptoSystem::CiphertextLength | ( | unsigned int | plaintextLength | ) | const`[pure virtual]`

| calculate length of ciphertext given length of plaintext Note: This function returns 0 if plaintextLength is not valid (too long). Implemented in PK_FixedLengthCryptoSystemImpl< PK_Encryptor >, PK_FixedLengthCryptoSystemImpl< PK_Decryptor >, DL_CryptoSystemBase< PK_Decryptor, DL_PrivateKey< SCHEME_OPTIONS::Element > >, DL_CryptoSystemBase< PK_Decryptor, DL_PrivateKey< T > >, DL_CryptoSystemBase< PK_Encryptor, DL_PublicKey< SCHEME_OPTIONS::Element > >, and DL_CryptoSystemBase< PK_Encryptor, DL_PublicKey< T > >. Referenced by PK_DefaultEncryptionFilter::Put2().

virtual bool PK_CryptoSystem::ParameterSupported | ( | const char * | name | ) | const`[pure virtual]`

| this object supports the use of the parameter with the given name some possible parameter names: EncodingParameters, KeyDerivationParameters Implemented in TF_CryptoSystemBase< PK_Decryptor, TF_Base< TrapdoorFunctionInverse, PK_EncryptionMessageEncodingMethod > >, TF_CryptoSystemBase< PK_Encryptor, TF_Base< RandomizedTrapdoorFunction, PK_EncryptionMessageEncodingMethod > >, DL_CryptoSystemBase< PK_Decryptor, DL_PrivateKey< SCHEME_OPTIONS::Element > >, DL_CryptoSystemBase< PK_Decryptor, DL_PrivateKey< T > >, DL_CryptoSystemBase< PK_Encryptor, DL_PublicKey< SCHEME_OPTIONS::Element > >, and DL_CryptoSystemBase< PK_Encryptor, DL_PublicKey< T > >.

virtual unsigned int PK_CryptoSystem::FixedCiphertextLength | ( |  | ) | const`[inline, virtual]`

| return fixed ciphertext length, if one exists, otherwise return 0 Note: "Fixed" here means length of ciphertext does not depend on length of plaintext. It usually does depend on the key length. Reimplemented in TF_CryptoSystemBase< PK_Decryptor, TF_Base< TrapdoorFunctionInverse, PK_EncryptionMessageEncodingMethod > >, and TF_CryptoSystemBase< PK_Encryptor, TF_Base< RandomizedTrapdoorFunction, PK_EncryptionMessageEncodingMethod > >. Definition at line 1129 of file cryptlib.h. Referenced by PK_Decryptor::FixedLengthDecrypt().

The documentation for this class was generated from the following file:

- cryptlib.h